﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="index.aspx.cs" Inherits="aspnet_crud_operations_entity_framework_index" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Crud Operations in Entity Framework | YogiHosting Demo</title>
    <link rel="icon" type="image/png" href="http://www.yogihosting.com/wp-content/themes/yogi-yogihosting/Images/favicon.ico" />
    <style>
        body {
            background: #111 no-repeat;
            background-image: -webkit-gradient(radial, 50% 0, 150, 50% 0, 300, from(#444), to(#111));
        }

        h1, h2 {
            text-align: center;
            color: #FFF;
        }

            h2 a {
                color: #0184e3;
                text-decoration: none;
            }

        .container {
            width: 960px;
            margin: auto;
            color: #FFF;
            font-size: 25px;
        }

            .container h3 {
                text-decoration: underline;
                text-align: center;
            }

            .container h4, .container h5 {
                margin: 10px 0;
                padding-left: 190px;
            }

            .container h4 {
                color: #0184e3;
            }

            .container h5, .container a {
                color: #00e8ff;
            }

            .container .insertLink {
                text-align: center;
            }

            .container .studentFormDiv label {
                display: block;
                margin: 0;
                text-transform: capitalize;
            }

            .container .studentFormDiv span {
                display: block;
                color: red;
            }

            .container .studentFormDiv > form > div > div {
                padding-top: 25px;
            }

            .container table {
                width: 80%;
                padding-left: 190px;
                color: #FFF;
                font-size: 25px;
            }

                .container table td {
                    width: 50%;
                }

            .container .studentDiv {
                margin: 25px auto 0 auto;
            }

                .container .studentDiv > tbody > tr:nth-child(1) {
                    background-color: #0f40e0;
                }

                .container .studentDiv > tbody > tr:not(:nth-child(1)) {
                    background-color: #ff6a00;
                }

                .container .studentDiv > tbody > tr.pagingDiv {
                    background-color: #f2f2f2;
                }

                    .container .studentDiv > tbody > tr.pagingDiv table {
                        padding-left: 10px;
                        width: 35%;
                    }

                        .container .studentDiv > tbody > tr.pagingDiv table td {
                            display: inline;
                        }

        #content {
            border: dashed 2px #CCC;
            padding: 10px;
        }

        .pagingDiv a, .pagingDiv span {
            display: inline-block;
            padding: 0px 9px;
            margin-right: 4px;
            border-radius: 3px;
            border: solid 1px #c0c0c0;
            background: #e9e9e9;
            box-shadow: inset 0px 1px 0px rgba(255,255,255, .8), 0px 1px 3px rgba(0,0,0, .1);
            font-size: .875em;
            font-weight: bold;
            text-decoration: none;
            color: #717171;
            text-shadow: 0px 1px 0px rgba(255,255,255, 1);
        }

            .pagingDiv a:hover {
                background: #fefefe;
                background: -webkit-gradient(linear, 0% 0%, 0% 100%, from(#FEFEFE), to(#f0f0f0));
                background: -moz-linear-gradient(0% 0% 270deg,#FEFEFE, #f0f0f0);
            }

            .pagingDiv a.active {
                border: none;
                background: #616161;
                box-shadow: inset 0px 0px 8px rgba(0,0,0, .5), 0px 1px 0px rgba(255,255,255, .8);
                color: #f0f0f0;
                text-shadow: 0px 0px 3px rgba(0,0,0, .5);
            }

        .pagingDiv span {
            color: #f0f0f0;
            background: #616161;
        }
    </style>
</head>
<body>
    <h1>Crud Operations in Entity Framework</h1>
    <h2><a href="http://www.yogihosting.com/crud-operations-ef">Read the tutorial on YogiHosting »</a></h2>
    <form id="form1" runat="server">
        <div class="container">
            <div id="content">
                <div class="insertLink"><a href="index.aspx">Insert Student</a></div>
                <h4 id="operationH4" runat="server"></h4>
                <h5 id="resultH5" runat="server"></h5>
                <div class="studentFormDiv">
                    <table>
                        <tbody>
                            <tr>
                                <td>
                                    <label>Name</label>
                                    <asp:TextBox ID="nameTextBox" runat="server"></asp:TextBox>
                                    <span id="nameSpan"></span>
                                </td>
                                <td>
                                    <label>Age</label>
                                    <asp:TextBox ID="ageTextBox" runat="server"></asp:TextBox>
                                    <span id="ageSpan"></span>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <label>Standard</label>
                                    <asp:TextBox ID="standardTextBox" runat="server"></asp:TextBox>
                                    <span id="standardSpan"></span>
                                </td>
                                <td>
                                    <label>Percent</label>
                                    <asp:TextBox ID="percentTextBox" runat="server"></asp:TextBox>
                                    <span id="percentSpan"></span>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <label>Address</label>
                                    <asp:TextBox ID="addressTextBox" runat="server"></asp:TextBox>
                                    <span id="addressSpan"></span>
                                </td>
                                <td>
                                    <label>Status</label>
                                    <asp:DropDownList ID="statusDropDownList" runat="server">
                                        <asp:ListItem Value="Select" Text="Select"></asp:ListItem>
                                        <asp:ListItem Value="True" Text="Active"></asp:ListItem>
                                        <asp:ListItem Value="False" Text="InActive"></asp:ListItem>
                                    </asp:DropDownList>
                                    <span id="statusSpan"></span>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <asp:Button ID="submitButton" runat="server" Text="Submit" OnClick="submitButton_Click" />
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <asp:GridView ID="gridView" CssClass="studentDiv" runat="server" AllowCustomPaging="true" AllowPaging="true" OnPageIndexChanging="gridView_PageIndexChanging" PagerStyle-CssClass="pagingDiv" AutoGenerateColumns="false" OnRowCommand="gridView_RowCommand" OnRowEditing="gridView_RowEditing" OnRowDeleting="gridView_RowDeleting">
                    <Columns>
                        <asp:BoundField DataField="Id" HeaderText="Id" />
                        <asp:BoundField DataField="Name" HeaderText="Name" />
                        <asp:BoundField DataField="Address" HeaderText="Address" />
                        <asp:BoundField DataField="Age" HeaderText="Age" />
                        <asp:BoundField DataField="Standard" HeaderText="Standard" />
                        <asp:BoundField DataField="Percent" HeaderText="Percent" />
                        <asp:BoundField DataField="AddedOn" HeaderText="AddedOn" />
                        <asp:TemplateField HeaderText="Status">
                            <ItemTemplate>
                                <%#Eval("Status") %>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Edit">
                            <ItemTemplate>
                                <asp:ImageButton ID="editImageButton" runat="server" CommandName="edit" CommandArgument='<%#Eval("Id") %>' ImageUrl="Image/edit-icon.png" />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Delete">
                            <ItemTemplate>
                                <asp:ImageButton ID="deleteImageButton" runat="server" CommandName="delete" CommandArgument='<%#Eval("Id") %>' ImageUrl="Image/delete-icon.png" />
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
            </div>
        </div>
    </form>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
    <script>
        $(document).ready(function () {
            $("#submitButton").click(function (e) {
                var returnValidate = Validate();
                if (returnValidate) {
                    return tru
                }
                return false;
            });

            function Validate() {
                var errorCounter = 0;
                $("#nameSpan").text("");
                $("#ageSpan").text("");
                $("#standardSpan").text("");
                $("#percentSpan").text("");
                $("#statusSpan").text("");

                if ($("#nameTextBox").val() == "") {
                    $("#nameSpan").text("Please enter name");
                    errorCounter++;
                }

                if ($("#ageTextBox").val() == "") {
                    $("#ageSpan").text("Please enter age");
                    errorCounter++;
                }
                else if (!(isPositiveInteger($("#ageTextBox").val()))) {
                    $("#ageSpan").text("Age should be in +ve integers");
                    errorCounter++;
                }

                if ($("#standardTextBox").val() == "") {
                    $("#standardSpan").text("Please enter standard");
                    errorCounter++;
                }

                if ($("#percentTextBox").val() == "") {
                    $("#percentSpan").text("Please enter percent");
                    errorCounter++;
                }
                else if (!(isPercent($("#percentTextBox").val()))) {
                    $("#percentSpan").text("Percent should be upto 2 places of decimals like 76.82");
                    errorCounter++;
                }

                if ($("#statusDropDownList").val() == "Select") {
                    $("#statusSpan").text("Please select status");
                    errorCounter++;
                }

                if (errorCounter == 0) {
                    return true;
                }
                else {
                    return false;
                }
            }

            function isPositiveInteger(n) {
                return (n.match(/^\d*$/));
            }

            function isPercent(n) {
                return (n.match(/^(0(?!\.00)|[1-9]\d{0,6})\.\d{2}$/));
            }
        });
    </script>
</body>
</html>
