﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.Entity.Core.Objects;

public partial class aspnet_crud_operations_entity_framework_index : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            BindStudent(0);
            string id = Request.QueryString["id"];
            if (id != null)
            {
                operationH4.InnerText = "Update Student";
                BindStudentById(id);
            }
            else
                operationH4.InnerText = "Insert Student";
        }
    }

    public void BindStudent(int page)
    {
        using (var context = new Entities())
        {
            int pageSize = 4;
            int pageNo = page == 0 ? 1 : page;

            gridView.PageSize = pageSize;
            var result = context.sp_GetStudent(pageNo, pageSize);

            gridView.VirtualItemCount = context.Students.Count();
            gridView.DataSource = result;
            gridView.DataBind();
        }
    }
    public void BindStudentById(string id)
    {
        using (var context = new Entities())
        {
            var result = context.sp_GetStudentById(Convert.ToInt32(id));
            sp_GetStudentById_Result student = new sp_GetStudentById_Result();
            student = result.ToList().FirstOrDefault();
            nameTextBox.Text = student.Name;
            ageTextBox.Text = Convert.ToString(student.Age);
            standardTextBox.Text = student.Standard;
            percentTextBox.Text = Convert.ToString(student.Percent);
            addressTextBox.Text = student.Address;
            statusDropDownList.ClearSelection();
            statusDropDownList.Items.FindByValue(Convert.ToString(student.Status)).Selected = true;

            operationH4.InnerText = "Update Student";
        }
    }
    protected void submitButton_Click(object sender, EventArgs e)
    {
        using (var context = new Entities())
        {
            ObjectParameter result = new ObjectParameter("result", typeof(String));
            ObjectParameter createdId = new ObjectParameter("createdId", typeof(String));
            if (Request.QueryString["id"] == null)
                context.sp_InsertStudent(nameTextBox.Text, addressTextBox.Text, Convert.ToInt32(ageTextBox.Text), standardTextBox.Text, Convert.ToDecimal(percentTextBox.Text), Convert.ToBoolean(statusDropDownList.SelectedItem.Value), result, createdId);
            else
                context.sp_UpdateStudent(Convert.ToInt32(Request.QueryString["id"]), nameTextBox.Text, addressTextBox.Text, Convert.ToInt32(ageTextBox.Text), standardTextBox.Text, Convert.ToDecimal(percentTextBox.Text), Convert.ToBoolean(statusDropDownList.SelectedItem.Value), result);
            resultH5.InnerText = createdId.Value == null ? result.Value.ToString() : result.Value + " New Student Id is " + createdId.Value;
        }
        operationH4.InnerText = Request.QueryString["id"] == null ? "Add Student" : "Update Student";
        BindStudent(0);
    }

    protected void gridView_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        gridView.PageIndex = e.NewPageIndex;
        BindStudent(e.NewPageIndex + 1);
    }

    protected void gridView_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "edit")
            Response.Redirect("index.aspx?id=" + Convert.ToString(e.CommandArgument));
        else if (e.CommandName == "delete")
        {
            using (var context = new Entities())
            {
                ObjectParameter result = new ObjectParameter("result", typeof(String));
                context.sp_DeleteStudent(Convert.ToInt32(e.CommandArgument), result);
                resultH5.InnerText = Convert.ToString(result.Value);
            }
            BindStudent(0);
        }
    }

    protected void gridView_RowEditing(object sender, GridViewEditEventArgs e)
    {

    }

    protected void gridView_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {

    }
}